var PARAMETERS = {
    // -------
    // Project
    // -------
    'jsFileVersion':'8.0911_r2',
    'releaseNotes': 'delete PAGES PARAMS',
    'appVersion': null,
    'playerVersion': null,
    'siteID': null,
    'userId': null,
    'trackUsername': null,
    'productID': null,
    'appType':null, //6:iphone. 7:ipad, 8:android phone, 13:android pad
    'updateInterval': null,
    'convention': '1.0',
    'player': null, //playerVersion
    // --------
    // Library
    // --------
    '_trackType': null,
    '_trackCategory': null,
    '_trackAction': null,
    '_mediaType': null,
    '_mediaStatus': null, // LIVE or VOD
    '_mediaAction': null, // player actions.
    '_clientID': null,
    '_viewID': null,
    '_msgID': null,
    '_sessionID': null, //Identifier of a session/visit.
    '_playTime': null, // time played, the current playback position in the stream,int (in seconds).
    '_watchedTime': null, // real watched time. int(seconds)
    '_deviceType': null, // Type of the device hardware.
    '_networkType': null, //carrier,wifi,landline
    '_os':null, //Type of app in perspective of target hosting device.
    '_carrierName' : null, //he name of network carrier. If cannot get carrier information, set it to be 'unknown'.
    '_dropFrameCount' : null, //Number of dropped frames since last video message
    '_bufferTime' : null, //bufferTime The duration of a buffer event perceived by audience since last video message, in millisecond.
    '_startupTime': null, //The duration from clicking 'play' button to starting playing video, in millisecond.
    '_streamURL': null, // playback url.
    '_streamLength': null,
    '_streamType': null,
    '_windowMode': null,
    '_bandwidth' : null,
    '_bitrate' : null,
    '_switchMethod' : null,
    '_dropFrameCount' : null,
    '_bufferTime': null,
    '_startupTime': null,
    '_pctValue': '0',   //percent 25,50, 75, 100
    '_heartbeatValue' : '300',  //seconds
    '_pageViewDuration': null, // the stay time (in seconds) of this page view
    // --------
    // Custom
    // --------
    'pageName': null,
    'errorMessage': null,
    // Purchase
    'purchaseSku': null,
    'purchaseName': null,
    'isPPVPackage': null,
    'purchasePrice': null,
    'purchaseAmount': null,
    'purchaseCurrency': null,
    // AD
    'adType': 'preroll',
    'adPlayedDuration': '30',
    //Streaming
    'ppt': null, // publish oint request json string.
    //Game
    'id': null, // maybe game id, program id, channel id
    'homeTeamName': null,
    'awayTeamName': null,
    'gameStartDate': null,  //please pass long number to here, game is start date, program is release date.
    'gameStatus': null, //-1: unavailbe, 0: upcoming, 1:live, 2:dvr, 3:final, 4:final, game is gameStatus
    'isGame': null, //true: team game, false: event game
    'name': null, //it display name from feed, maybe program name, channel name, event name.

    //program, live channel,
    'beginDateTime': null, //which is only for progrmae live event and archive.

    'liveStatus': null,  //-1: unavailbe, 0: upcoming, 1:live, 2:dvr, 3:final, 4:final, program is live status

    'releaseDate': null, //it is for program video, live channel should no the release date.

    //nba customer:
    'lang':null, //language was set by app
    'source':null, //article source <article/blog/nba world/syndicated>
    'categoryDetail': null,
    'teamName':null,

    'tcid':null, //purchase transaction Id.

    'requestUrl':'', //http request url
    'errorMessage':'',
    'httpStatusCode':'',
    'responseContent':''
};

// ---------
// Constants
// ---------
var GAMETYPES = {
    '1' : 'broadcast',
    '2' : 'home',
    '4' : 'away',
    '8' : 'condensed (broadcast)',
    '16' : 'condensed home',
    '32' : 'condensed away',
    '64' : 'full continuous highlight',
    '128' : 'halftime highlight',
    '256' : 'audio',
    '512' : 'audio home',
    '1024' : 'audio away'
}

var APPTYPES = {
    '6':'iphone',
    '7':'ipad',
    '8':'android_phone',
    '13':'android_pad',
    '14':'kindle',
    '138':'google_tv',
    '139':'apple_tv',
    '142':'fire_tv'
}

var PCTVALUES = {
    '25': "Video 25 Percent",
    '50': "Video 50 Percent",
    '75': "Video 75 Percent",
    '100': "Video Complete"
}


var PCTAUDIOVALUES = {
    '25': "Audio 25 Percent",
    '50': "Audio 50 Percent",
    '75': "Audio 75 Percent",
    '100': "Audio Complete"
}

var HEARTBEATVALUES = {
    '60': "Video 1 minute update",
    '300': "Video 5 minutes update"
}
// -------
// Events
// -------

var EVENTS = {
    'trackTypes': [
        'APP',
        'PAGE',
        'EVENT',
        'VIDEO',
        'AD'
    ],

    'trackCategories': [
        'PROGRAM',
        'CHANNEL',
        'TEAMGAME',
        'EVENTGAME',
        'LINK',
        'NEWS',
        'ALERT',
        'TOP_STORIES',
        'VIDEOS',
        'GATE',
        'LIVE_EVENTS',
        'FIGHT_LIBRARY',
        'COLLECTIONS',
        'FEATURES_SHOW',
        'MY_QUEUE',
        'FAVORITES',
        'VIEW_HISTORY',
        'PLAYLIST',
        'WEIGHT_CLASS',
        'A-Z',
        'RANKING',
        'STATS',
        'VIDEOS',
        'UPCOMING_EVENTS',
        'PAST_EVENTS',
        'TV',
        'PRE',
        'LIVE',
        'POST',
        'LOGIN',
        'FORGOT_PASSWORD',
        'REGISTER',
        'PURCHASE_SUCCESS',
        'FIGHTERS',
        'CONTENT',
        'FIGHTS',
        'REGISTER_SUCCESS',
        'REGISTER_ERROR',
        'LOGIN_SUCCESS',
        'LOGIN_ERROR',
        'PURCHASE_SELECTION',
        'PURCHASE_BILLING',
        'PURCHASE_CONFIRMATION'
    ],

    'trackActions': [
        'START',
        'STOP',
        'HEARTBEAT',
        'CLICK',
        'AD',
        'REMOVE',
        'FIRSTLAUNCH',
        'CRASH',
        'SUCCESS',
        'ERROR'
    ],

    'mediaTypes': [
        'PROGRAM',
        'CHANNEL',
        'TEAMGAME',
        'EVENTGAME'
    ],

    'mediaStatus': {
        'LIVE': 'Video Live',
        'VOD': 'Video On Demand',
        'AUDIOLIVE': 'Audio Live',
        'AUDIOVOD' : 'Audio On Demand'
    },

    'mediaActions': {
        'START': "Video Start",
        'PCT': 'Video xx percent',
        'QUIT': 'Video Stop',
        'COMPLETE' : 'Video Complete',
        'PAUSE': "Video Pause",
        'HEARTBEAT': "Video Duration",
        'ERROR': "Playing Error"
    },

    'mediaAudioActions': {
        'START': "Audio Start",
        'PCT': 'Audio xx percent',
        'QUIT': 'Audio Stop',
        'COMPLETE' : 'Audio Complete',
        'PAUSE': "Audio Pause",
        'HEARTBEAT': "Audio Duration",
        'ERROR': "Playing Error"
    }
};

// --------
// Toolkit
// --------

function match(target, key) {
    return typeof target == 'string' ? target.contains(key) : target.indexOf(key) != -1;
}

function generateMeidaResult(data, result){

    return result;
}

function generateEventResult(data, result){

    result['gaDimension'] = getCustomGAParams(data, 'gaDimension');
    result['gaMetric'] = getCustomGAParams(data, 'gaMetric');

    return result;
}

function generatePageResult(data, result){
    result['pageName'] = result.screenName;
    result['gaDimension'] = getCustomGAParams(data, 'gaDimension');
    result['gaMetric'] = getCustomGAParams(data, 'gaMetric');
    return result;
}

function convertLowerCase(str){
    return str ? str.toLowerCase() : str;
}

function getPureRequestUrl(url){
    var index = url.indexOf('?');
    if (index>0)
        return url.substring(0,index);
    else
        return url
}

//data format: 2015-06-15T14:00:00.000
function parseDateTimeStr(dateTimeStr, format) {
    //Month(M), Day(d), Hour(h), Minutes(m), Seconds(s), Quarter(q)  1-2 character，
    //Year(y) posible to use 1-4 character，milliseconds(S)
    //yyyy-MM-dd hh:mm
    //yyyyMMdd
    //yyyy-MM-dd

    var dateStr = dateTimeStr;
    if(dateTimeStr) {
        try {
            var dateTimeReg = /^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})T(\d{1,2}):(\d{1,2}):(\d{1,2})*/;
            var r = dateTimeStr.match(dateTimeReg);

            var year = r[1];
            var month = r[3];
            var date = r[4];
            var hours = r[5];
            var minutes = r[6];
            var seconds = r[7];

            if (format == 'yyyy-MM-dd hh:mm') {
                dateStr = '' + year + "-" + month + "-" + date + ' ' + hours + ":" + minutes;
            }
            else if (format == 'yyyy-MM-dd') {
                dateStr = '' + year + "-" + month + "-" + date;
            }
            else {
                dateStr = '' + year + month + date;
            }


        } catch (error) {
            //console.log(error)
        }
    }

    return dateStr;
}

/*
awayTeamCode at homeTeamCode on gameDate(yyyyMMdd)[- gameType] [- camera(camX)] [- audioStream]
NOTE - the gameType, camera, and audioStream values are optional so omit if doesn't apply
Examples:
20140601:NYI at NYR on 20150610
20140601:Michigan at Wisconsin on 20150610 - away
20140601:NYI at NYR on 20150610 - cam5
20140601:Michigan at Wisconsin on 20150610 - home - es
20140601:NYI at NYR on 20150610 - away - cam5 - fr
123234:program Name on 20150610
*/
function getContentName(data) {

    var contentName = '';
    var pptObj = getPPTObj(data);

    if (data.awayTeamName && data.homeTeamName) {

        contentName = data.awayTeamName + ' at ' +
        data.homeTeamName + ' on ' +
        parseDateTimeStr(data.gameStartDate) +
        (GAMETYPES[pptObj.gt] ? ' - ' + GAMETYPES[pptObj.gt] : '') +
        (pptObj.cam ? ' - camera(' + pptObj.cam + ')' : '') +
        (pptObj.audio ? ' - ' + (data.audioChannel || 'audio') : '');

    }
    else if(data._mediaType == 'CHANNEL' || data._trackCategory == 'CHANNEL'){

        contentName = data.name + ": " + (getEpgDisplayName(data) || 'no show');

    }
    else if(data.id || data.name || data.releaseDate || data.beginDateTime || data.gameStartDate){
        var myDate = data.releaseDate || data.beginDateTime || data.gameStartDate || null;
        var displayDate = '';
        if(myDate) {
            displayDate = parseDateTimeStr(myDate);
            displayDate = ' on ' + displayDate;
        }

        if(data.name) contentName += data.name;
        if(displayDate) contentName += displayDate;

        contentName +=  (GAMETYPES[pptObj.gt] ? ' - ' + GAMETYPES[pptObj.gt] : '') +
        (pptObj.cam ? ' - camera(' + pptObj.cam + ')' : '') +
        (pptObj.audio ? ' - ' + (data.audioChannel || 'audio') : '');
    }
    else{
        contentName = data.name || '';
    }

    if(data.id){
        contentName = data.id + ':' + contentName;
    }


    return contentName;
}

function getEpgDisplayName(data){
    if(data.epgT && data.epgE){
        return data.epgT + '-' + data.epgE;
    }else if(data.epgT){
        return data.epgT;
    }else if(data.epgE){
        return data.epgE;
    }else{
        return data.epgName;
    }
}

function getPageName(data){

    var desc = '';

    var category = data._trackCategory;
    if(category)  desc = '/' + data._trackCategory;

    var name = getContentName(data);
    if(name) desc = desc + ': ' + name;

    return '/' + data.pageName + (desc || '');

}

function getPPTObj(data){

    var pptObj = {};

    if(data.ppt){
        try {pptObj = JSON.parse(data.ppt);} catch (error) {};
    }else {
        pptObj.id = data.id;
        pptObj.extid = data.gameExtId;
        pptObj.gt = data.gameType;
        pptObj.gs = data.gameState || data.gameStatus;
        pptObj.trailer = data.isTrailer;
        pptObj.audio = data.isAudio;
        pptObj.cam = data.camera;
        pptObj.st = data.dvrStartTime;
        pptObj.dur = data.dvrDuration;
    }

    return pptObj;
}


//data["gaCustomDimension"] = "userType,test1,test2,test3";
//data["gaCustomMetric"] = "userType,test1,test2,test3";
function getCustomGAParams(data, type){
    var originalValue = "";
    var result = "";

    if(type == "gaDimension"){
        originalValue = data.gaCustomDimension;
    }else if(type == "gaMetric"){
        originalValue = data.gaCustomMetric;
    }else{
        //
    }

    if(originalValue) {
        var scopeValue = originalValue.split(",");
        var scopeDataValue = new Array();
        for (var j in scopeValue) {
            scopeDataValue.push(data[scopeValue[j]]);
        }
        if(scopeDataValue.length > 0) {
            result = scopeDataValue.join(",");
        }
    }

    return result;
}

function getUserType(data) {
    var userType = 'anonymous';

    if (data.isVip == 'true') {

        userType = "vipuser"

    }
    else if (data.userId && data.mvpdName) {
        userType = 'reg_and_mvpd';

        if (data.hasSubscription == 'true') {
            userType = 'sub_and_mvpd';
            if (data.isFreeTrail == 'true') {
                userType = 'trial_and_mvpd';
            }
        }
    }
    else if (data.userId) {

        userType = 'member';

        if (data.hasSubscription == 'true') {

            userType = 'subscriber';

        } else if (data.isFreeTrail == 'true') {

            userType = 'trialsubscriber';

        }
    } else if (data.mvpdName) {

        userType = 'mvpdsubscriber';

    }

    return userType;
}

// ---------
// Tracker
// ---------
module.exports = {

    'settings': {
        'VOD_MILESTONES': '25,50,75', // Percentage event settings, it means, when video play through 25%, 50%, 75%, will sent PCT events.
        'LIVE_DURATION': '0+,30',   // it means live heartbeat value always 300s
        'VOD_DURATION': '0+,30',    // it means vod heartbeat value always 300s
        'TIME_INTERVAL' : 'REAL_WATCHED_TIME', // possible value: DEFAULT, REAL_WATCHED_TIME
        'OVER_SEEK_MILESTONE': false //
    },

    'trackMedia': function (data) {
        data["userType"] = getUserType(data);
        var pptObj = getPPTObj(data);

        // Data Prepossessing
        if(pptObj.audio || data.isAudio){
            if(data._mediaStatus == 'LIVE') data._mediaStatus = "AUDIOLIVE";
            if(data._mediaStatus == 'VOD') data._mediaStatus = "AUDIOVOD";
        }

        if(data._mediaType == 'CHANNEL'){
            if(pptObj.st || data.dvrStartTime){
                data._mediaStatus == 'VOD'
            }
        }

        if(data._mediaAction == 'COMPLETE'){
              data._pctValue  = '100';
              data._mediaAction = 'PCT';
        }

        var actionValue = EVENTS.mediaActions[data._mediaAction];
        var pctValue = PCTVALUES[data._pctValue];

        if(data._mediaStatus.indexOf("AUDIO") != -1){
            actionValue = EVENTS.mediaAudioActions[data._mediaAction];
            pctValue = PCTAUDIOVALUES[data._pctValue];
        }
        //End

        if (match(['VOD', 'LIVE', 'AUDIOLIVE', 'AUDIOVOD'], data._mediaStatus)
            && match(['PROGRAM','TEAMGAME','EVENTGAME','CHANNEL'], data._mediaType)
            && match(['START'], data._mediaAction)) {

            return generateMeidaResult(data, {
                 'category' : EVENTS.mediaStatus[data._mediaStatus],
                 'action' : actionValue,
                 'label': getContentName(data),
                 'value' : 1,
                 'gaDimension': getCustomGAParams(data, 'gaDimension'),
                 'gaMetric': getCustomGAParams(data, 'gaMetric')
            });
        }
        else if (match(['VOD', 'LIVE', 'AUDIOLIVE', 'AUDIOVOD'], data._mediaStatus)
            && match(['PROGRAM','TEAMGAME','EVENTGAME','CHANNEL'], data._mediaType)
            && match(['PCT'], data._mediaAction)) {

            return generateMeidaResult(data, {
                'category' : EVENTS.mediaStatus[data._mediaStatus],
                'action' : pctValue,
                'label': getContentName(data),
                'value' : 1
            });
        }
        else if (match(['VOD', 'LIVE', 'AUDIOLIVE', 'AUDIOVOD'], data._mediaStatus)
            && match(['PROGRAM','TEAMGAME','EVENTGAME','CHANNEL'], data._mediaType)
            && match(['HEARTBEAT'], data._mediaAction)) {

            return generateMeidaResult(data, {
                'category' : EVENTS.mediaStatus[data._mediaStatus],
                'action' : actionValue,
                'label': getContentName(data),
                'value' : data._heartbeatValue || PARAMETERS._heartbeatValue
            });
        }
        else if (match(['AD'], data._mediaType)
            && match(['START'], data._mediaAction)) {

            return generateMeidaResult(data, {
                'category' : "AD",
                'action' : "START",
                'label': data.adId || data.id || getContentName(data),
                'value' : 0
            });
        }else if (match(['AD'], data._mediaType)
            && match(['COMPLETE'], data._mediaAction)) {

            return generateMeidaResult(data, {
                'category' : "AD",
                'action' : "COMPLETE",
                'label': data.adId || data.id || getContentName(data),
                'value' : 0
            });
        }
        else {

            return generateMeidaResult(data, {
                "errorCode": "EVENTUNDEFINED",
                "errorMsg": data._mediaType + '_' + data._mediaStatus + '_' + data._mediaAction
            });
        }
    },

    'track': function(data) {
        data["userType"] = getUserType(data);
        if (match(['PAGE'], data._trackType) && match(['START'], data._trackAction)) {

            //Hit,Session,User,Product
            //Hit:userType,

            return generatePageResult(data, {
                'screenName': getPageName(data)
            });

        }else  if (match(['PAGE'], data._trackType)
            && match(['CLICK'], data._trackAction)) {

            return generatePageResult(data, {

                'screenName': getPageName(data)

            });
        }else  if (match(['EVENT'], data._trackType)
            && match(['ALERT'], data._trackCategory)
            && match(['ADD','REMOVE'], data._trackAction)) {

            var actionDesc = {
                'ADD':'Add Alert',
                'REMOVE':'Remove Alert'
            }

            return generateEventResult(data, {
                'category' : 'Game Alerts',
                'action' : actionDesc[data._trackAction],
                'label': getContentName(data),
                'value' : 1

            });
        }else  if (match(['EVENT'], data._trackType)
            && match(['CUSTOM'], data._trackCategory)) {

                return generateEventResult(data, {
                    'category' : data.gaCategory || data.customCategory || 'Custom Events',
                    'action' : data.gaAction || data.customAction || 'Click',
                    'label': data.gaLable || data.customLabel || '',
                    'value' : data.gaVaue || data.customValue || '1'
                });


        }else  if (match(['EVENT'], data._trackType)
            && match(['SESSIONLOST'], data._trackCategory)) {

            return generateEventResult(data, {
                'category' : 'Events',
                'action' : 'SESSIONLOST',
                'label': data.trackUserName,
                'value' : 1
            });
        }
        else{

            return generateEventResult(data, {
                "errorCode": "EVENTUNDEFINED",
                "errorMsg": data._trackType + '_' + data._trackCategory + '_' + data._trackAction
            });

        }
        }
    }
