var PARAMETERS = {
    // Project
    'jsFileVersion':'7.0411_r2',
    'releaseNotes': 'Js file version should be [ProjectName]_Y.MMdd',
    'appVersion': null,
    'appShortVersion': null,
    'osVersion' : null,
    'bundleId': null,
    'playerVersion': null,
    'siteID': null,
    'userId': null,
    'isVip': null,
    'hasSubscription': null,
    'isFreeTrail' : null,
    'isIAP' : null,
    'productID': null,
    'appType': null, //6:iphone. 7:ipad, 8:android phone, 13:android pad, 14: Kindle, 142: FireTV, 138: Google TV.
    'updateInterval': null,
    'convention': '1.0',
    'player': null, //playerVersion

    // Library
    '_libVersion': null,
    '_trackType': null,
    '_trackCategory': null,
    '_trackAction': null,
    '_mediaType': null,
    '_mediaStatus': null, // LIVE or VOD
    '_mediaAction': null, // player actions.
    '_clientID': null,
    '_viewID': null,
    '_msgID': null,
    '_sessionID': null, //Identifier of a session/visit.
    '_playTime': null, // time played, the current playback position in the stream,int (in seconds).
    '_watchedTime': null, // real watched time. int (seconds)
    '_deviceType': null, // Type of the device hardware.
    '_networkType': null, //carrier,wifi,landline
    '_os': null, //Type of app in perspective of target hosting device.
    '_carrierName': null, //he name of network carrier. If cannot get carrier information, set it to be 'unknown'.
    '_dropFrameCount': null, //Number of dropped frames since last video message
    '_bufferTime': null, //bufferTime The duration of a buffer event perceived by audience since last video message, in millisecond.
    '_startupTime': null, //The duration from clicking 'play' button to starting playing video, in millisecond.
    '_streamURL': null, // playback url.
    '_streamLength': null,
    '_windowMode': null, // normal,fullscreen,mosaic,fullmosaic,PIP
    '_bandwidth': null,
    '_bitrate': null,
    '_switchMethod': null,
    '_streamType': null,
    '_dropFrameCount': null,
    '_bufferTime': null,
    '_startupTime': null,
    '_pctValue': '0',   //percent 25,50, 75
    '_heartbeatValue' : '300',  //seconds
    '_pageViewDuration': null, // the stay time (in seconds) of this page view

    // Custom
    'pageName': null, //Qos Page Tracking
    'errorMessage': null,
    // Purchase
    'purchaseSku': null,
    'purchaseName': null,
    'isPPVPackage': null,
    'purchasePrice': null,
    'purchaseAmount': null,
    'purchaseCurrency': null,
    'purchaseOrderId': null,
    // AD
    'adType': 'preroll',
    'adPlayedDuration': '30',
    //Streaming
    'ppt': null, // publish point request json string.
    'streamType': null, //0:live, 1:vod
    //Game
    'id': null, // maybe game id, program id, channel id
    'gameExtId':null,
    'homeTeamName': null,
    'awayTeamName': null,
    'gameStartDate': null, //please pass long number to here, game is start date, program is release date. 2015-12-28T07:30:00.000
    'gameStatus': null, //-1: unavailbe, 0: upcoming, 1:live, 2:dvr, 3:final, 4:final, game is gameStatus
    'gameState' : null, //which is Compatible value of gameStatus
    'isGame': null, //true: team game, false: event game
    'name': null, //it display name from feed, maybe program name, channel name, event name.
    'gameType':null, //Specifies the game type of the game publishing point.
    'camera':'',
    'audioLang': '',
    'epgName': null, //it is for channel dvr title name, which come from epg feed, • t – e, if both property “t” and “e” exist in EPG feed; t, if property “e” is not available in EPG feed.
    'epgShowTime' : null, //'2015-06-15T14:00:00.000' Start local time, it should be sl in epg feed. 2015-12-28T07:30:00.000
    //program, live channel,
    'beginDateTime': null, //which is only for progrmae live event and archive.
    'liveState': null, //-1: unavailbe, 0: upcoming, 1:live, 2:dvr, 3:final, 4:final, program is live status
    'releaseDate': null, //it is for program video, live channel should no the release date. 2016-10-21T11:53:00.123
    'isTrailer':'',
    'isAudio':'',
    'dvrStartTime':'', // long int.
    'dvrDuration':'', //

    //nba customer:
    'lang':null, //language was set by app
    'source':null, //article source <article/blog/nba world/syndicated>
    'categoryDetail': null,
    'teamName':null,
    'airingId':null,

    'sportId':null,
    'sportName':null,
    'leagueName':null,
    'userAgent':null,
    'enableCC' : null,

    //btn
    'videoRating':null,
    'videoSource':null,
    'videoDuration':null,
    'season':null,
    'episodeNum':null,
    'mvpdName':null,
    'schoolName':null,
    "videoType": null, //free, btntv, btnplus

    //customer Core data
    'screenOrientation': null, //landscape|portrait
    'connected_device':null, //airplay, chromecast,
    '_meidaTrackType': null //'MEDIA_BASE|MEDIA_PLUGIN'

};

// Constants
var GAMETYPES = {
    '1' : 'broadcast',
    '2' : 'home',
    '4' : 'away',
    '8' : 'condensed (broadcast)',
    '16' : 'condensed home',
    '32' : 'condensed away',
    '64' : 'full continuous highlight',
    '128' : 'halftime highlight',
    '256' : 'audio',
    '512' : 'audio home',
    '1024' : 'audio away'
}

var APPTYPES = {
    '6': 'iphone',
    '7': 'ipad',
    '8': 'android_phone',
    '13': 'android_pad',
    '14':'kindle',
    '138':'google_tv',
    '139':'apple_tv',
    '142':'fire_tv'
}

var PCTVALUES = {
    '25': "video.25PercentComplete",
    '50': "video.50PercentComplete",
    '75': "video.75PercentComplete",
    '100': "video.complete"
}

var HEARTBEATVALUES = {
    '30': "video.live0.5minute",
    '60': "video.live1minute",
    '300': "video.live5minute"
}

var PAGES = [
    'LATEST_HEADLINES', //not login, splash
    'LATEST_NEWS',
    'LATEST_SOCIAL',
    'LATEST_ALLSTAR',
    'NEWSDETAIL',
    'GAMES',
    'VIDEOS',
    'STATS',
    'MORE',
    'LOGIN',
    'REGISTER',
    'SELECTTEAM',
    'NOTIFICATION',
    'LANGUAGE',
    'MYPACKAGES',
    'MESSAGE',
    'SETTINGS',
    'NBASTORE',
    'PLAYOFFMATCHUPS',
    'IMPORTANTDATES',
    'NBADRAFT',
    'STANDINGS',
    'PLAYER',
    'TEAMDETAIL',
    'FAVORITETEAM',
    'MYPROFILE',
    'WEBVIEW',
    'LIVE_CHANNEL'
];

// ---------
// Events
// ---------
var EVENTS = {

    //site_section
    'trackTypes': [
        'APP',
        'PAGE',
        'EVENT',
        'VIDEO',
        'AD'
    ],

    //site_subsection
    'trackCategories': [

        'AUTHENTICATION',
        'LATEST_HEADLINE',
        'LATEST_NEWS',
        'LATEST_NEWS_ARTICLE',
        'LATEST_SOCIAL',

        'GAMES',
        'VIDEOS_ONDEMAND',
        'VIDEOS_VAULT',
        'VIDEOS_NBATV',
        'STATS',
        'MORE',

        'MORE_LOGIN',
        'MORE_LOGIN_LOGIN',
        'MORE_LOGIN_GETSTART',
        'MORE_PACKAGE_LOGIN',
        'MORE_REGISTER',
        'MORE_SELECTTEAM',
        'MORE_TEAM_DETAIL',
        'MORE_PLAYER',
        'MORE_STANDINGS',
        'MORE_NBADRAFT',
        'MORE_IMPORTANT_DATES',
        'MORE_PLAYOFF_MATCHUPS',
        'MORE_PACKAGES',
        'MORE_NBA_STORE',
        'MORE_SETTINGS',
        'MORE_SETTINGS_FEEDBACK',
        'MORE_SETTINGS_MYLOCATION',
        'MORE_SETTINGS_RESTORE',
        'MORE_SETTINGS_VIEWPACKAGE',

        'MORE_SETTINGS_LANGUAG',
        'MORE_SETTINGS_FAVORITETEAM',
        'SETTINGS_NOTIFICATION',
        'WEBVIEW',

        'LIVE_CHANNEL'
    ],

    'trackActions': [
        'START',
        'STOP',
        'HEARTBEAT',
        'CLICK',
        'AD',
        'REMOVE',
        'FIRSTLAUNCH',
        'CRASH',
        'SUCCESS',
        'ERROR',
        'SELECTOR',
        'DOWNLOAD',
        'EXPORT',
        'ENABLED',
        'DISABLED'
    ],

    'mediaTypes': [
        'PROGRAM',
        'CHANNEL',
        'TEAMGAME',
        'EVENTGAME',
        'AD'
    ],

    'mediaStatus': {
        'LIVE': 'live',
        'VOD': 'vod',
        'AUDIOLIVE': 'live',
        'AUDIOVOD' : 'audio'
    },

    'mediaActions': {
        'INIT':'Init media request',
        'START': "Video start",
        'PCT': 'Video xx percent',
        'QUIT': 'Video stop',
        'COMPLETE':'Video vomplete',
        'PAUSE': "Video pause",
        'HEARTBEAT': "Video Duration",
        'ERROR': "Playing Error",
        'SEEK_START' :'Seek Start',
        'SEEK_COMPLETE' : 'Seek Complete',
        'BUFFER_START' : 'Buffer Start',
        'BUFFER_COMPLETE' : 'Buffer Complete',
        'CHAPTER_START': 'Chapter Start',
        'CHAPTER_COMPLETE' : 'Chapter Complete',
        'BITRATE_CHANGE' : 'Bitrate Change'
    }
};

// ---------
// Toolkit
// ---------

function match(target, key) {

    return typeof target == 'string' ? target.contains(key) : target.indexOf(key) != -1;

}

function getSubscription(str){

    return str ? str.replace('_',' ').toLowerCase() : str;

}

function convertLowerCase(str){

    return str ? str.toLowerCase() : str;

}

function getDeviceType(data){
    if(data.appType=='6' || data.appType =='8')
        return 'phone app';
    else{
        return 'tablet app';
    }
}

function getPlatform(data){
    if(data.appType=='6' || data.appType =='7')
        return 'IOS';
    else if(data.appType=='8' || data.appType =='13'){
        return 'Android';
    }else{
        return "Unknown";
    }
}

function  getAppVersion(data) {
    return data.appShortVersion + "(" + data.appVersion + ")";
}

function generateMediaResult(data, result){

    result['video.fsid'] = data.videoRating || 'no rating';
    result['video.source'] = data.videoSource || 'no source';
    result['video.networkName'] = data._carrierName || 'no network name';
    result['video.playerID'] = getPlayerName(data);
    result['video.title'] = getContentName(data) + (data.videoDuration ? ("|"+data.videoDuration) : '');
    result['video.show'] = getContentName(data) || 'no show name';
    result['video.season'] = data.season || 'no season';
    result['video.episodeNumber'] = data.episodeNum || 'no episode number';
    result['video.embeddedHost'] = getPlayerName(data);
    result['video.mvpd'] = data.mvpdName || 'not authenticated';
    result['video.contentSubscriptionType'] = 'unlocked';
    result['video.hometeam'] = data.homeTeamName || 'no home team';
    result['video.visitingteam'] = data.awayTeamName || 'no visiting team';

    return result;
}

function generateMediaPluginResult(data, result){

    return result;

}

function generateEventResult(data, result){

    result['_OAEventName'] = getContentName(data);

    return result;

}

function generatePageResult(data, result){
    var baseData = {
        'SITE_ID': (data.appName || data._appName),
        'SECTION': data.pageName,
        'SUB_SECTION': data._trackCategory || 'default',
        'PAGE_TYPE': 'main screen'
    }

    result['_OAPageName'] = baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION + ":" + baseData.PAGE_TYPE;
    result['page.siteContentDrillDown']= baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION + ":" + baseData.PAGE_TYPE;;
    result['page.channel'] = baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION ;
    result['page.server'] = baseData.SITE_ID;
    result['page.pagesConv'] = baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION + ":" + baseData.PAGE_TYPE;
    result['page.contentLevel1'] = baseData.SITE_ID;
    result['page.contentLevel2'] = baseData.SITE_ID + ":" + baseData.SECTION ;
    result['page.contentLevel3'] = baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION;
    result['page.contentLevel4'] = baseData.SITE_ID + ":" + baseData.SECTION + ":" + baseData.SUB_SECTION + (data.name ? ":" + getContentName(data) : '') ;
    result['page.timePartingHour'] = getPartingData()['hour'];
    result['page.timePartingDay'] = getPartingData()['week'];
    result['page.type'] = baseData.PAGE_TYPE;
    result['page.sponsorName'] = 'no sponsor"';
    result['page.deviceID'] = data._clientID;

    return result;

}

function parseDateTimeStr(dateTimeStr) {

    var dateStr = dateTimeStr;
    if(dateTimeStr) {
        try {
            var dateTimeReg = /^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})T(\d{1,2}):(\d{1,2}):(\d{1,2})*/;
            var r = dateTimeStr.match(dateTimeReg);

            var year = r[1];
            var month = r[3];
            var date = r[4];
            var hours = r[5];
            var minutes = r[6];
            var seconds = r[7];

            dateStr = year + (month < 10 ? '0' + month : month) + (date < 10 ? '0' + date : date);
        }catch(error){}
    }
    return dateStr;

}

function getPartingData(){
    var date = new Date();
    var week = {
        "0" : "Sunday",
        "1" : "Monday",
        "2" : "Tuesday",
        "3" : "Wednesday",
        "4" : "Thursday",
        "5" : "Friday",
        "6" : "Saturday"
    };

    var partingData={
        'hour': date.getHours() + ":" + date.getMinutes(),
        'week': week[date.getDay()]
    }

    return partingData;
}

function formatDatetime(){
    var dt = new Date();
    var nowTime = dt.getTime();
    var estTime  = nowTime - 4*60*60*1000;
    var estDate = new Date(estTime);
    var yyyy = estDate.getUTCFullYear();
    var MM = estDate.getUTCMonth() + 1;
    var dd = estDate.getUTCDate();
    var hh = estDate.getUTCHours();
    var mm =  estDate.getUTCMinutes();

    return estDateStr = yyyy + '_' + (MM<10?'0'+MM:MM) + (dd<10?'0'+dd:dd) + '_' + (hh<10?'0'+hh:hh) + (mm<30?'00':'30');
}
/*
 awayTeamCode at homeTeamCode on gameDate(yyyyMMdd)[- gameType] [- camera(camX)] [- audioStream]
 NOTE - the gameType, camera, and audioStream values are optional so omit if doesn't apply
 Examples:
 NYI at NYR on 20150610
 Michigan at Wisconsin on 20150610 - away
 NYI at NYR on 20150610 - cam5
 Michigan at Wisconsin on 20150610 - home - es
 NYI at NYR on 20150610 - away - cam5 - fr
 */
function getContentName(data, appendDuration) {

    var contentName = '';
    var pptObj = getPPTObj(data);

    if (data.awayTeamName && data.homeTeamName) {

        contentName = data.awayTeamName + ' at ' +
            data.homeTeamName + ' on ' +
            parseDateTimeStr(data.gameStartDate) +
            (pptObj.gt ? ' - ' + GAMETYPES[pptObj.gt] : '') +
            (pptObj.cam ? ' - camera' + pptObj.cam : '') +
            (pptObj.audio ? ' - ' + pptObj.audio : '')
    }else if (data._mediaType == 'CHANNEL' || data._trackCategory == 'CHANNEL') {
        if(appendDuration) {
            contentName = "no show|" + data.name + "|no season|no episode|no airdate|3600";
        }else{
            contentName =  data.name;
        }
    }
    else if(data.id || data.name || data.releaseDate || data.beginDateTime || data.gameStartDate){
        var myDate = data.releaseDate || data.beginDateTime || data.gameStartDate || null;
        var displayDate = '';
        if(myDate) {
            displayDate = parseDateTimeStr(myDate);
            displayDate = ' on ' + displayDate;
        }

        //if(data.id) contentName = data.id + ':';
        if(data.name) contentName += data.name;
        if(displayDate) contentName += displayDate;

        contentName +=  (pptObj.gt ? ' - ' + GAMETYPES[pptObj.gt] : '') +
            (pptObj.cam ? ' - camera(cam' + pptObj.cam + ')' : '') +
            (pptObj.audio ? ' - ' + pptObj.audio : '');

    }else{
        contentName =  data.name;
    }

    if(appendDuration)
    {
        if (contentName == '') {
            return null;
        } else {
            var streamingLength = 3600;
            if (data._streamLength && data._streamLength != '0' && data._streamLength != '-1') {
                streamingLength = data._streamLength;
            }
            if (data._mediaType == 'CHANNEL' || data._trackCategory == 'CHANNEL') {
                return contentName;
            } else {
                return contentName + "|" + streamingLength;
            }
        }
    }else{
        return contentName;
    }
}


function getEpgDisplayName(data){
    if(data.epgT && data.epgE){
        return data.epgT + '-' + data.epgE;
    }else if(data.T){
        return data.T;
    }else if(data.epgE){
        return data.E;
    }else{
        return data.epgName;
    }
}

function getPlayerName(data){
    return (data.appName || data._appName) + " " + getPlatform(data) + "|v" + data.appVersion + " (" + data.appShortVersion +")"|| "no playername";
}

function getPPTObj(data){

    var pptObj = {};

    if(data.ppt){
        try {pptObj = JSON.parse(data.ppt);} catch (error) {};
    }else {
        pptObj.id = data.id;
        pptObj.extid = data.gameExtId;
        pptObj.gt = data.gameType;
        pptObj.gs = data.gameState || data.gameStatus;
        pptObj.trailer = data.isTrailer;
        pptObj.audio = data.isAudio;
        pptObj.cam = data.camera;
        pptObj.st = data.dvrStartTime;
        pptObj.dur = data.dvrDuration;
    }

    return pptObj;
}

var lastPlayedTime = 0;

function getWatchedTimeDuration(data){

    var duration =  data._watchedTime - this.lastPlayedTime;
    lastPlayedTime = data._watchedTime;

    return duration;
}

var SETTINGS = {
    'OA_TRACK_TYPE': ['MEDIA_PLUGIN']
}

// --------
// Tracker
// --------
module.exports = {

    'lastPlayedTime': 0,

    'settings': {
        'VOD_MILESTONES': '25,50,75,100', // Percentage event settings, it means, when video play through 25%, 50%, 75%, 100%, will sent PCT events.
        'LIVE_DURATION': '0-300,60|301+,300', //it means 0-300s, heartbeat value is 60s, after 300s, heartbeat value is 300s
        'VOD_DURATION': '0+,300',  // it is has the same rule of LIVE_DURATION
        'TIME_INTERVAL' : 'REAL_WATCHED_TIME', // possible value: DEFAULT, REAL_WATCHED_TIME
        'OVER_SEEK_MILESTONE': true,  // seek over the video milestone, still need sent the milestone event.
        'OA_TRACK_TYPE': ['MEDIA_PLUGIN'] //['MEDIA_BASE','MEDIA_PLUGIN'] ////seek over the video milestone, do not need sent the milestone event.
    },

    'trackMedia': function (data) {

        var pptObj = getPPTObj(data);

        if(pptObj.audio || data.isAudio){
            if(data._mediaStatus == 'LIVE') data._mediaStatus = "AUDIOLIVE";
            if(data._mediaStatus == 'VOD') data._mediaStatus = "AUDIOVOD";
        }

        if(data._mediaType == 'CHANNEL'){
            if(pptObj.st || data.dvrStartTime){
                data._mediaStatus == 'VOD'
            }
        }

        if(match(SETTINGS.OA_TRACK_TYPE, data._mediaTrackType) && data._mediaTrackType == 'MEDIA_BASE') {
            if (match(['INIT'], data._mediaAction)) {
                return {
                    '_OAMediaName':getContentName(data),
                    'playerName' : getPlayerName(data)
                }
            }else if (match(['VOD'], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME','CHANNEL'], data._mediaType)
                && match(['START'], data._mediaAction)) {

                lastPlayedTime = 0;

                return generateMediaResult(data, {
                    '_OAMediaName' : 'video.start',
                    'video.concatTitle': getContentName(data),
                    'video.type': 'video',
                    'video.format': "long-form"
                });
            } else if (match(['LIVE'], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME', 'CHANNEL'], data._mediaType)
                && match(['START'], data._mediaAction)) {

                lastPlayedTime = 0;

                return generateMediaResult(data, {
                    '_OAMediaName' : 'video.start',
                    'video.concatTitle': getContentName(data),
                    'video.type': 'video',
                    'video.format': "live stream"
                });
            }
            else if (match(['VOD'], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME', 'CHANNEL'], data._mediaType)
                && match(['PCT'], data._mediaAction)) {

                return generateMediaResult(data, {

                    '_OAMediaName': PCTVALUES[data._pctValue],
                    'video.concatTitle': getContentName(data),
                    'video.type': 'video',
                    'video.format': "long-form",
                    '&&events' : "event72",
                    '&&products' : ";;;;event72=" + getWatchedTimeDuration(data)

                });
            }
            else if (match(['LIVE'], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME', 'CHANNEL'], data._mediaType)
                && match(['HEARTBEAT'], data._mediaAction)) {

                return generateMediaResult(data, {
                    '_OAMediaName': HEARTBEATVALUES[data._heartbeatValue] || "video.heartbeat",
                    'video.concatTitle': getContentName(data),
                    'video.type': 'video',
                    'video.format': "live stream",
                    '&&events' : "event72",
                    '&&products' : ";;;;event72=" + getWatchedTimeDuration(data)
                });

            }else if (match(['LIVE','VOD'], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME', 'CHANNEL'], data._mediaType)
                && match(['PAUSE'], data._mediaAction)) {

                var formats = {
                    'LIVE':'live stream',
                    'VOD':'long-form'
                }

                return generateMediaResult(data, {
                    '_OAMediaName': "video.pause",
                    'video.concatTitle': getContentName(data),
                    'video.type': 'video',
                    'video.format': formats[data._mediaStatus],
                    '&&events' : "event72",
                    '&&products' : ";;;;event72=" + getWatchedTimeDuration(data)
                });

            }
            else {
                return {
                    "errorCode": "EVENTUNDEFINED",
                    "errorMsg": data._mediaType + '_' + data._mediaStatus + '_' + data._mediaAction
                };
            }
        }
        else if(match(SETTINGS.OA_TRACK_TYPE, data._mediaTrackType) && data._mediaTrackType == 'MEDIA_PLUGIN') {
            if(match(['INIT'], data._mediaAction)) {
                return generateMediaPluginResult(data, {
                    'aaPlugin.channel' : data.id,
                    'playerName' : getPlayerName(data),
                    'ovp':'NeuLion',
                    'appVersion': getPlayerName(data),
                    'ssl': true
                });
            }
            else if(match(['VOD','LIVE',], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME','CHANNEL'], data._mediaType)
                && match(['START'], data._mediaAction)) {

                var streamingLength = 3600;
                if(data._streamLength && data._streamLength != '0' && data._streamLength != '-1'){
                    streamingLength = data._streamLength;
                }

                var assetType = 'clip';
                if(data._mediaStatus == 'LIVE'){
                    assetType = 'no type';
                }


                var video_format = 'long-form';
                if(data._streamLength > 0 && data._streamLength < 3600) {
                    video_format = 'short-form';
                }

                var streamingType = EVENTS.mediaStatus[data._mediaStatus];
                var videoTitle = getContentName(data, true) || "no title|3600"
                var cateTitle =  'no show|' + getContentName(data) + '|no season|no episode|no airdate|' + data._streamLength + '|' + video_format;
                if(data._mediaType == 'CHANNEL'){
                    streamingType = 'linear';
                    videoTitle = getContentName(data) + "|3600" || "no title|3600";
                    cateTitle = getContentName(data,true) + '|' + video_format;
                }


                return generateMediaPluginResult(data, {
                    'videoInfo.videoId' : data.id,
                    'videoInfo.name': getContentName(data) || 'no id',
                    'videoInfo.length': streamingLength,
                    'videoInfo.playhead': data._playTime,
                    'videoInfo.streamType': streamingType,
                    'videoInfo.playerName': getPlayerName(data),

                    'videoMetadata.a.media.show':getContentName(data) || 'no show name',
                    'videoMetadata.a.media.season': data.season || 'no season',
                    'videoMetadata.a.media.episode': data.episode || "no episode",
                    'videoMetadata.a.media.asset_id': data.id || 'no asset_id',
                    'videoMetadata.a.media.genre': data.genre || "no genre",
                    'videoMetadata.a.media.first_air_date':data.gameDate || data.releaseDate || 'no first air date',
                    'videoMetadata.a.media.digital_date':data.gameDate || data.releaseDate || 'no first digital date',
                    'videoMetadata.a.media.rating':data.rating || 'no rating',
                    'videoMetadata.a.media.originator': data.originator || 'no originator',
                    'videoMetadata.a.media.network': data.network || 'no network',
                    'videoMetadata.a.media.type':EVENTS.mediaStatus[data._mediaStatus],
                    'videoMetadata.a.media.ad_load': data.ad_load || "2",
                    'videoMetadata.a.media.pass.mvpd':data.mvpdName || 'no mvpd',
                    'videoMetadata.a.media.pass.authorized': data.authorized || 'unknown',
                    'videoMetadata.a.media.feed': data.feed || "no feed",
                    'videoMetadata.a.media.stream_format': data.stream_format || '1',


                    'videoCustomerMetadata.video.concattitle': cateTitle,
                    'videoCustomerMetadata.video.genre': data.genre || "no genre",
                    'videoCustomerMetadata.video.assettype': assetType,
                    'videoCustomerMetadata.video.contentadtype': data.contentadtype || "no video type",
                    'videoCustomerMetadata.video.lvs': video_format,
                    'videoCustomerMetadata.video.rating':data.rating || "no rating",
                    'videoCustomerMetadata.video.source':data.source || "natgeo" ||"no originator",
                    'videoCustomerMetadata.video.network': data.network || "natgeo",
                    'videoCustomerMetadata.video.playerid' : getPlayerName(data),
                    'videoCustomerMetadata.video.title': videoTitle,
                    'videoCustomerMetadata.video.wpr': data.id || "no wpr",
                    'videoCustomerMetadata.video.closedcaptionoptions':"no closed caption options",
                    'videoCustomerMetadata.video.show': getContentName(data) || "no show name",
                    'videoCustomerMetadata.video.season': data.season || "no season",
                    'videoCustomerMetadata.video.episode': data.episode || "no episode",
                    'videoCustomerMetadata.video.embeddedhost': getPlayerName(data),
                    'videoCustomerMetadata.video.url': data._streamURL || "no url",
                    'videoCustomerMetadata.video.mvpd': data.mvpdName || "no mvpd",
                    'videoCustomerMetadata.video.contentsubscriptiontype': data.authorized || "unknown",
                    'videoCustomerMetadata.video.ugcclip': data.ugcclip || "none" ,
                    'videoCustomerMetadata.video.airdate': data.airdate || "no airdate",
                    'videoCustomerMetadata.video.isResume':"false",
                    'videoCustomerMetadata.video.sportstype': data.sportstype || "no sport",
                    'videoCustomerMetadata.video.autoplay': data.autoplay || "unknown",
                    'videoCustomerMetadata.video.sponsor': data.sponsor || "no sponsor",
                    'videoCustomerMetadata.video.feedname': data.feedname || "no feed name",
                    'videoCustomerMetadata.video.stationid': data.stationid ||"no stationid",
                    'videoCustomerMetadata.video.isContinuous': data.isContinuous || "unknown",
                    'videoCustomerMetadata.video.screenLayout': data.screenLayout || "unknown"

                });

            }else if(match(['VOD','LIVE',], data._mediaStatus)
                && match(['PROGRAM', 'TEAMGAME', 'EVENTGAME','CHANNEL'], data._mediaType)
                && match(['CHAPTER_START_xxx'], data._mediaAction)) {

                return generateMediaPluginResult(data, {
                    'chapterInfo.name': getContentName(data),
                    'chapterInfo.length': data._streamLength,
                    'chapterInfo.position': '1',
                    'chapterInfo.startTime': '0',
                    'chapterMetadata.videoId':'test chapterMetadata'
                });
            }
            else if(match(['AD',], data._mediaStatus)
                && match(['START'], data._mediaAction)) {

                return generateMediaPluginResult(data, {
                    'adInfo.id' : data.id,
                    'adInfo.name': getContentName(data),
                    'adInfo.length': data.duration,
                    'adInfo.position': data._playTime,
                    'adMetadata.videoId':'test chapterMetadata',
                    'AdBreakInfo.playerName':getPlayerName(data),
                    'AdBreakInfo.name':'AdBreakInfo.name',
                    'AdBreakInfo.position':'AdBreakInfo.position',
                    'AdBreakInfo.startTime':'AdBreakInfo.startTime'
                });
            }
            else if(match(['HEARTBEAT'], data._mediaAction)) {

                return generateMediaPluginResult(data, {
                    'qosInfo.bitrate' : data._bitrate,
                    'qosInfo.fps': data._fps,
                    'qosInfo.droppedFrames': data._dropFrame,
                    'qosInfo.startupTime': data._startupTime
                });
            }else {
                return {
                    "errorCode": "EVENTUNDEFINED",
                    "errorMsg": data._mediaType + '_' + data._mediaStatus + '_' + data._mediaAction
                };
            }
        }
        else{
            return {
                "errorCode": "EVENTUNDEFINED",
                "errorMsg": data._mediaType + '_' + data._mediaStatus + '_' + data._mediaAction
            };
        }
    },

    'track': function (data) {
        if (match(['APP'], data._trackType)
            && match(['FIRSTLAUNCH_'], data._trackAction)) {

            return generateEventResult(data, {
                '_OAEventName': (data.appName || data._appName) + ':launch:application launch',
                'ActionName' : 'App Launch',
                'ActionLabel' : 'App Launch'
            });
        } else if (match(['PAGE'], data._trackType)
            && match(['START_'], data._trackAction)) {

            return generatePageResult(data, {
            });

        }
        else if (match(['EVENT'], data._trackType)
            && match(['START_'], data._trackAction)) {

            return generateEventResult(data, {
            });

        }
        else {
            return {
                "errorCode": "EVENTUNDEFINED",
                "errorMsg": data._trackType + '_' + data._trackCategory + '_' + data._trackAction
            };
        }

    }
}
